part of tecfy_core_client_package;

class DateTimeProperty extends StatefulWidget {
  final String? label;
  final String? description;
  final bool isRequired;
  final dynamic initalValue;
  final void Function(DateTime?)? onChanged;
  DateTimeProperty({
    this.label,
    this.description,
    this.isRequired = false,
    this.initalValue,
    this.onChanged,
  });
  @override
  _DateTimePropertyState createState() => _DateTimePropertyState();
}

class _DateTimePropertyState extends State<DateTimeProperty> {
  DateTime? _selectedDate;

  // DateTime? get _selectedDateTime {
  //   if (_selectedDate == null && _selectedTime == null) return null;
  //   if (_selectedTime == null) return _selectedDate!.toUtc();
  //   var d = _selectedDate;
  //   if (d == null) d = DateTime.now();
  //   d = d.add(
  //       Duration(hours: _selectedTime!.hour, minutes: _selectedTime!.minute));
  //   return d;
  // }

  @override
  void initState() {
    super.initState();
  }

  void _onPressed() async {
    // var value = await showDatePicker(
    //     builder: (context, child) {
    //       return Theme(
    //         data: Theme.of(context).copyWith(
    //           colorScheme: ColorScheme.light(
    //             primary: ThemeService.mainColor,
    //             onPrimary: Colors.white,
    //             onSurface: Colors.black,
    //           ),
    //           textButtonTheme: TextButtonThemeData(
    //             style: TextButton.styleFrom(
    //               primary: Colors.black,
    //             ),
    //           ),
    //         ),
    //         child: child ?? Container(),
    //       );
    //     },
    //     context: context,
    //     firstDate: DateTime(1900),
    //     initialDate: _selectedDate ?? DateTime.now().toUtc(),
    //     lastDate: DateTime(2500));
    // if (value == null) return;
    // setState(() {
    //   _selectedDate = value.toUtc();
    // });
    // widget.onChanged?.call(_selectedDateTime);
  }

  void _onPressedTime() async {
    // var value = await showTimePicker(
    //   builder: (context, child) {
    //     return Theme(
    //       data: Theme.of(context).copyWith(
    //         colorScheme: ColorScheme.light(
    //           primary: ThemeService.mainColor,
    //           onPrimary: Colors.white,
    //           onSurface: Colors.black,
    //         ),
    //         textButtonTheme: TextButtonThemeData(
    //           style: TextButton.styleFrom(
    //             primary: Colors.black,
    //           ),
    //         ),
    //       ),
    //       child: child ?? Container(),
    //     );
    //   },
    //   context: context,
    //   initialTime: _selectedTime ?? TimeOfDay(hour: 12, minute: 0),
    // );
    // if (value == null) return;
    // setState(() {
    //   _selectedTime = value;
    // });
    // widget.onChanged?.call(_selectedDateTime);
  }

  _onPrint() {
    if (_selectedDate == null && widget.initalValue != null) {
      if (widget.initalValue is String) {
        print('trying to parse');
        var dateTime = BaseModel.parseUTC(widget.initalValue);
        if (dateTime != null) {
          _selectedDate = dateTime;
        }
      } else if (widget.initalValue is DateTime) {
        var dateTime = widget.initalValue; //.toLocal();
        if (dateTime != null) {
          _selectedDate = dateTime;
        }
      }
    }
  }

  @override
  Widget build(BuildContext context) {
    _onPrint();
    return widget.label == null
        ? Tooltip(message: widget.description ?? '', child: _getWidget())
        : Column(
            crossAxisAlignment: CrossAxisAlignment.start,
            children: <Widget>[
              SizedBox(height: 10),
              Row(
                children: [
                  Tooltip(
                      message: widget.description ?? '',
                      child: Text(
                        widget.label ?? '',
                        style: ThemeService.labelStyle,
                      )),
                  Text(
                    widget.isRequired ? '*' : '',
                    style: ThemeService.labelStyle.copyWith(color: Colors.red),
                  ),
                ],
              ),
              _getWidget(),
              // SizedBox(height: 10),
              // Container(height: 1, color: ThemeService.textSubColor)
            ],
          );
  }

  Widget _getWidget() {
    return DateTimePicker(
      type: DateTimePickerType.dateTime,
      dateMask: 'yyyy-MM-dd  HH:mm',
      initialValue: _selectedDate?.toLocal().toString(),
      firstDate: DateTime(2000),
      lastDate: DateTime(2100),
      style: TextStyle(color: Colors.black),
      //icon: Icon(Icons.event),
      // dateLabelText: 'Date',
      // timeLabelText: "Time",
      selectableDayPredicate: (date) {
        // Disable weekend days to select from the calendar
        // if (date.weekday == 6 || date.weekday == 7) {
        //   return false;
        // }

        return true;
      },
      onChanged: (val) {
        print('datetime selected $val');
        _selectedDate = DateTime.tryParse(val)?.toUtc();
        widget.onChanged?.call(_selectedDate);
      },
      validator: (val) {
        print(val);
        return null;
      },
      onSaved: (val) => print(val),
    );
  }
}
